/***************************************************************/
/*                   cutfield.c                                */
/*　　　入力行のN番目のフィールドだけを取り出します       　　 */
/*　　　入力は標準入力から与え，出力は標準出力に出力します     */
/* 使い方　                                                    */
/*$./cutfield (Nの値)　< (入力ファイル名）> (出力ファイル名) */
/***************************************************************/

/* ヘッダファイルのインクルード*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*記号定数の定義*/
#define TEXTLENGTH 4096 /*テキストの最大長*/
#define DELIM "\t" /*区切り文字*/


/*******************/
/*    main()関数   */
/*******************/
int main(int argc,char *argv[])
{
 char text[TEXTLENGTH] ;/*メッセージ*/
 double value ;/*取り出した数値*/
 char *field ;/*取り出したフィールド*/
 int n ; /*取り出すフィールドの位置*/
 int i ; /*繰り返しの制御変数*/

 /*コマンド引数のチェック*/
 if(argc!=2){
  fprintf(stderr,"使い方　$./cutfield (Nの値) \n") ;
  exit(1) ;
 }

 /*Nの値の設定*/
 if((n=atoi(argv[1]))<1){
  fprintf(stderr,"Nの値が不適切です\n") ;
  exit(1) ;
 }

 /*フィールドの取り出し*/
 while(fgets(text,TEXTLENGTH,stdin) != NULL){
  /*読み飛ばし*/
  field=strtok(text,DELIM) ; 
  for(i=1;i<n;++i){
   if((field=strtok(NULL,DELIM))==NULL){
    fprintf(stderr,"フィールドがありません\n") ;
    exit(1) ;
   } 
  }
  /*必要なフィールドの出力*/
  if(sscanf(field,"%lf",&value)==1)
   printf("%lf\n",value) ;
 }
 return 0 ;
}
