/*********************************************************/
/*                       lsm.c                           */
/*　最小二乗法による計算式の決定                         */
/*　統計的な機械学習の例題プログラムです                 */
/* 使い方　                                              */
/*       $./lsm       < (入力ファイル)                   */
/*　本文（１）式の係数a0およびa1を出力します             */
/*********************************************************/

/* ヘッダファイルのインクルード*/
#include <stdio.h>


/*記号定数の定義*/
#define TEXTLENGTH 4096 /*テキストの最大長*/ 

/*******************/ 
/*    main()関数   */ 
/*******************/ 
int main()
{
 char text[TEXTLENGTH] ;/*メッセージ*/
 double xi,yi ;/*入力された学習データ*/
 double sxi=0,syi=0,sxiyi=0,sxi2=0 ;/*各項の計算結果*/ 
 double a0,a1 ; /*係数*/
 int n=0 ;/*データの個数*/

 /*データの入力*/
 while(fgets(text,TEXTLENGTH,stdin) != NULL){
  if(sscanf(text,"%lf %lf",&xi,&yi)==2){
   /*変換成功，各項の計算*/
   sxi+= xi ; 
   syi+= yi ; 
   sxiyi+= xi*yi ; 
   sxi2+= xi*xi ;
   ++n ;
  } else{
   /*変換失敗，読み飛ばし*/
   fprintf(stderr,"不正なデータです:%s",text) ;
  } 
 }
 
 if(n>1){/*データが２個以上ある*/
  /*係数の計算*/
  a0=(sxi2*syi-sxiyi*sxi)/(n*sxi2-sxi*sxi) ; 
  a1=(n*sxiyi-sxi*syi)/(n*sxi2-sxi*sxi) ; 

  /*結果の出力*/
  printf("%lf\n%lf\n",a0,a1) ;
 }else{/*データが足りない*/
   fprintf(stderr,"データが足りません\n") ;
 }
 
 return 0 ;
}



