/***************************************************************/
/*                         ml1.c                               */
/*　前年比での気温の高低を，学習結果から予測するプログラム　　 */
/*　　　入力は標準入力から与え，出力は標準出力に出力します     */
/* 使い方　                                                    */
/*       $./ml1 　< (入力ファイル名）> (出力ファイル名)        */
/*　入力ファイルでは，気温の高低を+及び-で記述します           */
/*　出力ファイルには，予測結果を表示します                     */
/***************************************************************/

/* ヘッダファイルのインクルード*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*記号定数の定義*/
#define TEXTLENGTH 4096 /*テキストの最大長*/
#define PLUS 0   /*"+"に対応する整数値*/
#define MINUS 1  /*"-"に対応する整数値*/
#define NODATA -1  /*データが存在しない場合に対応する整数値*/

/*関数のプロトタイプの宣言*/
void learning(int last,int lastlast,int last3,int kb[2][2][2]) ;
                                     /* 過去データからの学習 */
void prediction(int last,int lastlast,int last3,int kb[2][2][2]) ;
                                     /* 学習結果に基づく予測 */

/*******************/
/*    main()関数   */
/*******************/
int main(int argc,char *argv[])
{
 char text[TEXTLENGTH] ;/*メッセージ*/
 int i ; /*繰り返しの制御変数*/
 int last,lastlast,last3 ; /*過去の値を保存する変数*/
 char chr ;/*入力された文字*/
 int kb[2][2][2]={0} ;/*データ数え上げのための表(配列）*/

 /*初期値の設定*/
 last3=lastlast=last=NODATA ;/*最初はデータが存在しない*/
 
 /*学習と予測の繰り返し*/
 while(fgets(text,TEXTLENGTH,stdin) != NULL){
  if(sscanf(text,"%c",&chr)==1){
   if(chr=='+'){/*入力は+*/
    last3=lastlast ;
    lastlast=last ;
    last=PLUS ;
   }
   else if(chr=='-'){/*入力は-*/
    last3=lastlast ;
    lastlast=last ;
    last=MINUS ;
   }
   else /*入力文字が無効*/
    break ;
   
   /*学習*/
   learning(last,lastlast,last3,kb) ;

   /*予測*/
   prediction(last,lastlast,last3,kb) ;
  }
 }
 /*学習の最終結果出力*/
 printf("学習結果\n") ;
 printf("+++ : %d\n",kb[PLUS][PLUS][PLUS]) ;
 printf("++- : %d\n",kb[MINUS][PLUS][PLUS]) ;
 printf("+-+ : %d\n",kb[PLUS][MINUS][PLUS]) ;
 printf("+-- : %d\n",kb[MINUS][MINUS][PLUS]) ;
 printf("-++ : %d\n",kb[PLUS][PLUS][MINUS]) ;
 printf("-+- : %d\n",kb[MINUS][PLUS][MINUS]) ;
 printf("--+ : %d\n",kb[PLUS][MINUS][MINUS]) ;
 printf("--- : %d\n",kb[MINUS][MINUS][MINUS]) ;


 return 0 ;
}

/************************/
/*   learning()関数     */
/* 過去データからの学習 */
/************************/
void learning(int last,int lastlast,int last3,int kb[2][2][2]) 
{
 /*過去のデータが存在するかどうか確認*/
 if((last!=NODATA)&&(lastlast!=NODATA)&&(last3!=NODATA))
  /*表を更新*/ 
  ++kb[last][lastlast][last3] ;
}

/************************/
/*  prediction()関数    */
/* 学習結果に基づく予測 */
/************************/
void prediction(int last,int lastlast,int last3,int kb[2][2][2])
{
 if(kb[last][lastlast][PLUS]>=kb[last][lastlast][MINUS])
  printf("+\n") ;/*予測値は+*/
 else
  printf("-\n") ;/*予測値は-*/
}


