/***************************************************************/
/*                 selectline.c                                */
/*入力行のN行目，N*2行目，N*3行目，・・・を取り出します        */
/*入力は標準入力から与え，出力は標準出力に出力します           */
/* 使い方　                                                    */
/*$./selectline (Nの値)　< (入力ファイル名）> (出力ファイル名) */
/***************************************************************/

/* ヘッダファイルのインクルード*/
#include <stdio.h>
#include <stdlib.h>

/*記号定数の定義*/
#define TEXTLENGTH 4096 /*テキストの最大長*/


/*******************/
/*    main()関数   */
/*******************/
int main(int argc,char *argv[])
{
 char text[TEXTLENGTH] ;/*メッセージ*/
 int n ; /*取り出す行*/
 int i=1 ;/*現在の行*/

 /*コマンド引数のチェック*/
 if(argc!=2){
  fprintf(stderr,"使い方　$./selectline (Nの値) \n") ;
  exit(1) ;
 }

 /*Nの値の設定*/
 if((n=atoi(argv[1]))<1){
  fprintf(stderr,"Nの値が不適切です\n") ;
  exit(1) ;
 }

 /*行の取り出し*/
 while(fgets(text,TEXTLENGTH,stdin) != NULL){
  /*必要な行を出力*/
  if((i%n)==0) printf("%s",text) ;
  ++i ;
 }
 return 0 ;
}
