/***************************************************************/
/*                        updown.c                             */
/*　　　入力値の変化を調べます                            　　 */
/*　　　1行にひとつの実数が記述されたファイルを入力し，　      */
/*      増加(+)減少(-)を出力します　　　　　　　　　　　　　　 */
/* 使い方　                                                    */
/* $./updown < (入力ファイル名）> (出力ファイル名)             */
/***************************************************************/

/* ヘッダファイルのインクルード*/
#include <stdio.h>
#include <stdlib.h>

/*記号定数の定義*/
#define TEXTLENGTH 4096 /*テキストの最大長*/

/*******************/
/*    main()関数   */
/*******************/
int main(int argc,char *argv[])
{
 char text[TEXTLENGTH] ;/*メッセージ*/
 double newval,lastval ; /*入力された数値*/

 /*初期値の設定*/
 if(fgets(text,TEXTLENGTH,stdin) == NULL){
  fprintf(stderr,"データがありません\n") ;
  exit(1) ;
 }
 if(sscanf(text,"%lf",&lastval)<1){
  fprintf(stderr,"データが不正です(%s)\n",text) ;
  exit(1) ;
 } 
 /*増減の計算*/
 while(fgets(text,TEXTLENGTH,stdin) != NULL){
   if(sscanf(text,"%lf",&newval)==1){
    /*変換成功*/
    if((newval-lastval)>=0) printf("+\n") ;
    else printf("-\n") ;
    lastval=newval ;/*更新*/
   }
 }
 
 return 0 ;
}

